/* HPCU Bi-Weekly Challenge: Fractal OpenMP
 * Solution
 * Author: Aaron Weeden, Shodor, 2015
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv) {
  const int nRows = 513;
  const int nCols = 513;
  const int middleRow = 0.5 * (nRows - 1);
  const int middleCol = 0.5 * (nCols - 1);
  const double step = 0.00625;
  const int depth = 100;
  int pixels[nRows][nCols];
  int row;
  int col;
  double myX;
  double myY;
  int i;
  double x;
  double y;
  double tmp;

  /* Loop over each pixel */
#pragma omp parallel for private(row, col, myX, myY, i, x, y, tmp)
  for (row = 0; row < nRows; row++) {
    for (col = 0; col < nCols; col++) {

      /* Set the (x,y) coordinate for each pixel */
      myX = (col - middleCol) * step;
      myY = (row - middleRow) * step;

      /* Calculate the number of iterations for each pixel */
      i = 0;
      x = 0;
      y = 0;
      while ((x*x + y*y < 4) && (i < depth)) {
        tmp = x*x - y*y + myX;
        y = 2*x*y + myY;
        x = tmp;
        i++;
      }

      /* Build array */
      pixels[row][col] = i;
    }
  }

  /* Display array */
  for (row = 0; row < nRows; row++) {
    for (col = 0; col < nCols; col++) {
      printf("%d,", pixels[row][col]);
    }
    printf("\n");
  }

  return 0;
}
